import type { IGomokuCandidateState, IGomokuPiece } from '../types/misc';
import type { IGomokuMover } from '../types/mover';
import type { IGomokuMoverContext } from '../types/mover-context';
import type { IGomokuMoverCounter } from '../types/mover-counter';
import type { IGomokuMoverState } from '../types/mover-state';
export interface IGomokuMoverProps {
    context: Readonly<IGomokuMoverContext>;
    counter: Readonly<IGomokuMoverCounter>;
    state: Readonly<IGomokuMoverState>;
}
export declare class GomokuMover implements IGomokuMover {
    readonly rootPlayerId: 0 | 1;
    protected readonly context: Readonly<IGomokuMoverContext>;
    protected readonly counter: Readonly<IGomokuMoverCounter>;
    protected readonly state: Readonly<IGomokuMoverState>;
    constructor(props: IGomokuMoverProps);
    resetRootPlayerId(rootPlayerId: number): void;
    init(pieces: ReadonlyArray<IGomokuPiece>): void;
    forward(posId: number, playerId: number): void;
    revert(posId: number): void;
    expand(nextPlayerId: number, candidates: IGomokuCandidateState[], candidateGrowthFactor: number, MAX_SIZE?: number): number;
    topCandidate(nextPlayerId: number): IGomokuCandidateState | undefined;
    score(nextPlayerId: number): number;
    isFinal(): boolean;
    couldReachFinal(nextPlayerId: number): boolean;
}
