import type { IGomokuCandidateState } from '../types/misc';
import type { IGomokuMover } from '../types/mover';
import type { IGomokuSearcher } from '../types/searcher';
export interface IAlphaBetaSearcherProps {
    MAX_CANDIDATE_COUNT: number;
    MIN_PROMOTION_SCORE: number;
    CANDIDATE_GROWTH_FACTOR: number;
    mover: IGomokuMover;
    deeperSearcher: IGomokuSearcher;
}
export declare class AlphaBetaSearcher implements IGomokuSearcher {
    readonly MAX_CANDIDATE_COUNT: number;
    readonly MIN_PROMOTION_SCORE: number;
    readonly CANDIDATE_GROWTH_FACTOR: number;
    readonly searchContext: Readonly<IGomokuMover>;
    readonly deeperSearcher: IGomokuSearcher;
    protected readonly _candidateCache: IGomokuCandidateState[];
    constructor(props: IAlphaBetaSearcherProps);
    search(rootPlayerId: number, alpha: number, beta: number): number | -1;
}
