import type { IGomokuCandidateState } from '../types/misc';
import type { IGomokuMover } from '../types/mover';
import type { IGomokuSearcher } from '../types/searcher';
export interface INarrowSearcherProps {
    MAX_SEARCH_DEPTH: number;
    MAX_CANDIDATE_COUNT: number;
    MIN_PROMOTION_SCORE: number;
    CANDIDATE_GROWTH_FACTOR: number;
    mover: IGomokuMover;
    deeperSearcher: IGomokuSearcher;
}
export declare class NarrowSearcher implements IGomokuSearcher {
    readonly MAX_SEARCH_DEPTH: number;
    readonly MAX_CANDIDATE_COUNT: number;
    readonly MIN_PROMOTION_SCORE: number;
    readonly CANDIDATE_GROWTH_FACTOR: number;
    readonly mover: Readonly<IGomokuMover>;
    readonly deeperSearcher: IGomokuSearcher;
    protected readonly _candidatesListCache: Record<number, IGomokuCandidateState[]>;
    constructor(props: INarrowSearcherProps);
    search(curPlayerId: number, alpha: number, beta: number, cur: number): number;
    protected _getCandidates(cur: number): IGomokuCandidateState[];
}
