import type { IGomokuPiece, IShapeScoreMap } from './types/misc';
import type { IGomokuMover } from './types/mover';
import type { IGomokuMoverContext } from './types/mover-context';
import type { IGomokuSearcher } from './types/searcher';
export interface IGomokuSolutionProps {
    MAX_ROW: number;
    MAX_COL: number;
    MAX_ADJACENT?: number;
    MAX_DISTANCE_OF_NEIGHBOR?: number;
    CANDIDATE_GROWTH_FACTOR?: number;
    scoreMap?: IShapeScoreMap;
    deeperSearcher?(mover: IGomokuMover): IGomokuSearcher;
}
export declare class GomokuSolution {
    readonly CANDIDATE_GROWTH_FACTOR: number;
    readonly scoreMap: Readonly<IShapeScoreMap>;
    readonly mover: Readonly<IGomokuMover>;
    protected readonly _moverContext: Readonly<IGomokuMoverContext>;
    protected readonly _searcher: IGomokuSearcher;
    constructor(props: IGomokuSolutionProps);
    init(pieces: ReadonlyArray<IGomokuPiece>, searcher?: IGomokuSearcher): void;
    forward(r: number, c: number, playerId: number): void;
    revert(r: number, c: number): void;
    minimaxSearch(nextPlayerId: number): [r: number, c: number];
}
