import type { IDeepSearcherProps } from '../searcher/deep';
import type { INarrowSearcherProps } from '../searcher/narrow';
import type { IShapeScoreMap } from '../types/misc';
import type { IGomokuMover } from '../types/mover';
import type { IGomokuSearcher } from '../types/searcher';
export declare type INarrowSearchOption = Omit<INarrowSearcherProps, 'mover' | 'deeperSearcher'>;
export declare type IDeepSearcherOption = Omit<IDeepSearcherProps, 'mover'>;
interface IProps {
    narrowSearcherOptions: INarrowSearchOption[];
    deepSearcherOption: IDeepSearcherOption;
    searchContext: IGomokuMover;
}
export declare const createGomokuSearcher: (props: IProps) => IGomokuSearcher;
export declare const createDefaultGomokuSearcher: (scoreMap: Readonly<IShapeScoreMap>, searchContext: IGomokuMover, options: {
    MAX_ADJACENT: number;
    CANDIDATE_GROWTH_FACTOR: number;
}) => IGomokuSearcher;
export {};
